# Generated by CMake

if("${CMAKE_MAJOR_VERSION}.${CMAKE_MINOR_VERSION}" LESS 2.6)
   message(FATAL_ERROR "CMake >= 2.6.0 required")
endif()
cmake_policy(PUSH)
cmake_policy(VERSION 2.6...3.21)
#----------------------------------------------------------------
# Generated CMake target import file.
#----------------------------------------------------------------

# Commands may need to know the format version.
set(CMAKE_IMPORT_FILE_VERSION 1)

# Protect against multiple inclusion, which would fail when already imported targets are added once more.
set(_targetsDefined)
set(_targetsNotDefined)
set(_expectedTargets)
foreach(_expectedTarget HPX::hpx HPX::wrap_main HPX::plugin HPX::component HPX::component_storage_component HPX::unordered_component HPX::partitioned_vector_component HPX::iostreams_component HPX::parcel_coalescing HPX::io_counters_component HPX::memory_component HPX::process_component)
  list(APPEND _expectedTargets ${_expectedTarget})
  if(NOT TARGET ${_expectedTarget})
    list(APPEND _targetsNotDefined ${_expectedTarget})
  endif()
  if(TARGET ${_expectedTarget})
    list(APPEND _targetsDefined ${_expectedTarget})
  endif()
endforeach()
if("${_targetsDefined}" STREQUAL "${_expectedTargets}")
  unset(_targetsDefined)
  unset(_targetsNotDefined)
  unset(_expectedTargets)
  set(CMAKE_IMPORT_FILE_VERSION)
  cmake_policy(POP)
  return()
endif()
if(NOT "${_targetsDefined}" STREQUAL "")
  message(FATAL_ERROR "Some (but not all) targets in this export set were already defined.\nTargets Defined: ${_targetsDefined}\nTargets not yet defined: ${_targetsNotDefined}\n")
endif()
unset(_targetsDefined)
unset(_targetsNotDefined)
unset(_expectedTargets)


# The installation prefix configured by this project.
set(_IMPORT_PREFIX "/usr")

# Create imported target HPX::hpx
add_library(HPX::hpx INTERFACE IMPORTED)

set_target_properties(HPX::hpx PROPERTIES
  INTERFACE_LINK_LIBRARIES "HPXInternal::hpx_full;HPXInternal::hpx_interface"
)

# Create imported target HPX::wrap_main
add_library(HPX::wrap_main INTERFACE IMPORTED)

set_target_properties(HPX::wrap_main PROPERTIES
  INTERFACE_LINK_LIBRARIES "HPXInternal::hpx_interface_wrap_main"
)

# Create imported target HPX::plugin
add_library(HPX::plugin INTERFACE IMPORTED)

set_target_properties(HPX::plugin PROPERTIES
  INTERFACE_COMPILE_DEFINITIONS "\$<\$<IN_LIST:\$<TARGET_PROPERTY:TYPE>,STATIC_LIBRARY;MODULE_LIBRARY;SHARED_LIBRARY;OBJECT_LIBRARY;INTERFACE_LIBRARY>:HPX_PLUGIN_NAME_DEFAULT=hpx_\$<TARGET_PROPERTY:NAME>>"
)

# Create imported target HPX::component
add_library(HPX::component INTERFACE IMPORTED)

set_target_properties(HPX::component PROPERTIES
  INTERFACE_COMPILE_DEFINITIONS "\$<\$<IN_LIST:\$<TARGET_PROPERTY:TYPE>,STATIC_LIBRARY;MODULE_LIBRARY;SHARED_LIBRARY;OBJECT_LIBRARY;INTERFACE_LIBRARY>:HPX_COMPONENT_NAME_DEFAULT=hpx_\$<TARGET_PROPERTY:NAME>>;\$<\$<IN_LIST:\$<TARGET_PROPERTY:TYPE>,STATIC_LIBRARY;MODULE_LIBRARY;SHARED_LIBRARY;OBJECT_LIBRARY;INTERFACE_LIBRARY>:HPX_COMPONENT_EXPORTS>"
)

# Create imported target HPX::component_storage_component
add_library(HPX::component_storage_component SHARED IMPORTED)

set_target_properties(HPX::component_storage_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "HPX::hpx;HPX::unordered_component"
)

# Create imported target HPX::unordered_component
add_library(HPX::unordered_component SHARED IMPORTED)

set_target_properties(HPX::unordered_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "HPX::hpx"
)

# Create imported target HPX::partitioned_vector_component
add_library(HPX::partitioned_vector_component SHARED IMPORTED)

set_target_properties(HPX::partitioned_vector_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "HPX::hpx"
)

# Create imported target HPX::iostreams_component
add_library(HPX::iostreams_component SHARED IMPORTED)

set_target_properties(HPX::iostreams_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "HPX::hpx"
)

# Create imported target HPX::parcel_coalescing
add_library(HPX::parcel_coalescing SHARED IMPORTED)

set_target_properties(HPX::parcel_coalescing PROPERTIES
  INTERFACE_LINK_LIBRARIES "HPX::hpx"
)

# Create imported target HPX::io_counters_component
add_library(HPX::io_counters_component SHARED IMPORTED)

set_target_properties(HPX::io_counters_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "HPX::hpx"
)

# Create imported target HPX::memory_component
add_library(HPX::memory_component SHARED IMPORTED)

set_target_properties(HPX::memory_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "HPX::hpx"
)

# Create imported target HPX::process_component
add_library(HPX::process_component SHARED IMPORTED)

set_target_properties(HPX::process_component PROPERTIES
  INTERFACE_LINK_LIBRARIES "HPX::hpx"
)

if(CMAKE_VERSION VERSION_LESS 3.0.0)
  message(FATAL_ERROR "This file relies on consumers using CMake 3.0.0 or greater.")
endif()

# Load information for each installed configuration.
get_filename_component(_DIR "${CMAKE_CURRENT_LIST_FILE}" PATH)
file(GLOB CONFIG_FILES "${_DIR}/HPXTargets-*.cmake")
foreach(f ${CONFIG_FILES})
  include(${f})
endforeach()

# Cleanup temporary variables.
set(_IMPORT_PREFIX)

# Loop over all imported files and verify that they actually exist
foreach(target ${_IMPORT_CHECK_TARGETS} )
  foreach(file ${_IMPORT_CHECK_FILES_FOR_${target}} )
    if(NOT EXISTS "${file}" )
      message(FATAL_ERROR "The imported target \"${target}\" references the file
   \"${file}\"
but this file does not exist.  Possible reasons include:
* The file was deleted, renamed, or moved to another location.
* An install or uninstall procedure did not complete successfully.
* The installation package was faulty and contained
   \"${CMAKE_CURRENT_LIST_FILE}\"
but not all the files it references.
")
    endif()
  endforeach()
  unset(_IMPORT_CHECK_FILES_FOR_${target})
endforeach()
unset(_IMPORT_CHECK_TARGETS)

# Make sure the targets which have been exported in some other
# export set exist.
unset(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE_targets)
foreach(_target "HPXInternal::hpx_full" "HPXInternal::hpx_interface" "HPXInternal::hpx_interface_wrap_main" )
  if(NOT TARGET "${_target}" )
    set(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE_targets "${${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE_targets} ${_target}")
  endif()
endforeach()

if(DEFINED ${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE_targets)
  if(CMAKE_FIND_PACKAGE_NAME)
    set( ${CMAKE_FIND_PACKAGE_NAME}_FOUND FALSE)
    set( ${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE "The following imported targets are referenced, but are missing: ${${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE_targets}")
  else()
    message(FATAL_ERROR "The following imported targets are referenced, but are missing: ${${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE_targets}")
  endif()
endif()
unset(${CMAKE_FIND_PACKAGE_NAME}_NOT_FOUND_MESSAGE_targets)

# Commands beyond this point should not need to know the version.
set(CMAKE_IMPORT_FILE_VERSION)
cmake_policy(POP)
